;************************************************************************
;*                 Shading of Bitmaps *very* fast via asm               *
;*                    This code is used from a VB Call                  *
;*                 by Daniel Aue for activevb.de 14.8.2003              *
;*                                                                      *
;*                     USE ENTIRELY AT YOUR OWN RISK.                   *
;*                 you may publish this source as long as               *
;*                      this commentblock stays in                      *
;************************************************************************
;V1.1: 14.8.2003 some Bugfixes (ReleaseDC, xor al,al added)
;V1.0: 12.8.2003 initial release
;Info: I used Masm 7 to create this source. I'm new to x86 ASM you might see this ;-)
;Thanks to Udo Schmidt for Optimization Tipps, unfortunatly the code does'nt look like
;mine anymore *g*

      .386                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive


    .code

pDest       EQU <DWORD Ptr [ebp]>
bmWidth     EQU <DWORD Ptr [ebp+4]>
bmHeight    EQU <DWORD Ptr [ebp+8]>
bmByteWidth EQU <DWORD Ptr [ebp+12]>
StartX      EQU <DWORD Ptr [ebp+16]>
StartY      EQU <DWORD Ptr [ebp+20]>
ShadeWidth  EQU <DWORD Ptr [ebp+24]>
ShadeHeight EQU <DWORD Ptr [ebp+28]>
ShadeValue   EQU <DWORD Ptr [ebp+32]>

start:
            push    ebp
            mov     ebp,esp
            
            push    edi
            push    esi
            push    ebx

            mov     ebp,[ebp+8]     ;get Pointer to Parameter Struct

;********** calculate start Point
            mov     edi,bmHeight
            sub     edi,ShadeHeight
            sub     edi,StartY        ;Top Down Bitmap
            imul    edi,bmByteWidth  ;multiply Y with Width in Bytes
            mov     ebx,StartX
            lea     eax,[2*ebx+ebx]         ;StartX * 3
            add     edi,eax
            add     edi,pDest		;add BMP Start->edi points now to the first pixel to be shaded
            
;********** set counting Registers
            mov ebx,ShadeWidth
            or  ebx,ebx
            je  ShadeFinished       ;exit if = 0
            lea edx,[2*ebx+ebx]

            mov ebx,ShadeHeight
            or  ebx,ebx
            je  ShadeFinished       ;exit if = 0


            mov     eax,ShadeValue
            cmp   eax,100
            je  ShadeFinished   ; = 100 
            cmc
            jc  ShadeFinished   ; > 100
            
            mov ch,al           ;rescue ShadeValue for case Any
            mov cl,25
            div cl
            or  ah,ah
            jnz ShadeAny        ;not 25,50,75
            xor al,3
            jz  Shade75         ; = 75
            jpo Shade2550       ; 25/50

            xor al,al
Shade0Line:   ;***********************************************
            mov ecx,edx		;Shade Area Width*3
            push edi
            rep stosb
            pop edi
            add edi,bmByteWidth		;next Line
            dec ebx
            jnz Shade0Line
            jmp ShadeFinished

Shade2550:   ;***********************************************
            mov cl,al
Shade2550Line:
            push    edx
            push    edi
Shade2550Pixel:
            shr byte ptr [edi],cl
            inc edi
            dec edx
            jnz Shade2550Pixel
            pop edi
            pop edx
            add edi,bmByteWidth		;next Line
            dec ebx
            jnz Shade2550Line
            jmp ShadeFinished

    
Shade75:   ;***********************************************
;********** initialize loop registers
            push edx
            push edi
            mov esi,edi
Shade75Pixel:
            lodsb
            shr al,1
            mov ah,al
            shr al,1
            add al,ah
            stosb
            dec edx
            jnz Shade75Pixel
            pop edi
            pop edx
            add edi,bmByteWidth		;next Line
            dec ebx 	;Shade Height
            jnz Shade75
            jmp ShadeFinished

ShadeAny:   ;***********************************************
;********** initialize loop registers
            mov cl,100
ShadeAnyLine:
            push edi
            push edx
            mov esi,edi
ShadeAnyPixel:
            lodsb
            mul ch
            div cl
            stosb
            dec edx
            jnz ShadeAnyPixel
            pop edx
            pop edi
            add edi,bmByteWidth		;next Line
            dec ebx
            jnz ShadeAnyLine
            jmp ShadeFinished

ShadeFinished:
            pop ebx
            pop esi
            pop edi
            pop ebp
            sbb eax,eax
            ret 16

end start
